<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=windows-1252">
	<TITLE>Clock Constraint Specification Language</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.3  (Win32)">
	<META NAME="CREATED" CONTENT="0;0">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGED" CONTENT="20080410;17021878">
	<META NAME="ProgId" CONTENT="Word.Document">
	<META NAME="Originator" CONTENT="Microsoft Word 11">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<META NAME="CHANGEDBY" CONTENT="Benoit Ferrero">
	<STYLE TYPE="text/css">
	<!--
		H1 { color: #000000 }
		P { color: #000000 }
		H2 { color: #000000 }
		H3 { color: #000000 }
		H4 { color: #000000 }
		A:link { color: #0000ff }
		A:visited { color: #0000ff }
	-->
	</STYLE>
</HEAD>
<BODY LANG="fr-FR" TEXT="#000000" LINK="#0000ff" VLINK="#0000ff" DIR="LTR">
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0cm"><FONT SIZE=6 STYLE="font-size: 26pt"><B>MARTE
Clock Constraint Specification Language</B></FONT></P>
<P ALIGN=CENTER><FONT SIZE=4 STYLE="font-size: 16pt">Charles Andr&eacute;,
Beno&icirc;t Ferrero, Fr&eacute;d&eacute;ric Mallet, Robert de Simone</FONT></P>
<P ALIGN=CENTER><FONT SIZE=4>Equipe-projet Aoste,</FONT></P>
<P ALIGN=CENTER>&nbsp;<FONT SIZE=4><SPAN LANG="en-US">INRIA
Sophia-Antipolis et laboratoire I3S (CNRS/UNSA)</SPAN></FONT></P>
<P>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<FONT FACE="Arial"><FONT SIZE=2 STYLE="font-size: 11pt"><SPAN LANG="en-US"><B>Contact&nbsp;:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
</B></SPAN></FONT></FONT>
</P>
<P>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="mailto: Charles.Andre@i3s.unice.fr?subject=[Grammaire CCSL]">
<FONT FACE="Arial"><FONT SIZE=2 STYLE="font-size: 11pt"><SPAN LANG="en-US"><B>Charles.Andre@i3s.unice.fr</B></SPAN></FONT></FONT></A></P>
<P>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="mailto:Benoit.ferrero@sophia.inria.fr?subject=[Grammaire CCSL]"><FONT FACE="Arial, sans-serif"><FONT SIZE=2 STYLE="font-size: 11pt"><B>Benoit.ferrero@sophia.inria.fr</B></FONT></FONT></A></P>
<P>&nbsp;</P>
<H1><A NAME="_Toc178562913"></A>1.Introduction</H1>
<P>This report contains a short presentation of the syntax of the
Clock Constraint Specification Language (CCSL) defined as annex to
the UML Profile for Modeling and Analysis of Real-Time Embedded
systems (MARTE), OMG specification ref realtime/07-05-01. &nbsp;The
language implementation and the full grammar definition were
conducted in part under the RNTL OpenEmbedd platform project.</P>
<P>The language relies on classical notations for Boolean, integer
and real expressions. It introduces a dedicated notation for
(infinite periodic) binary words. Binary words (sequences of 0s and
1s) are used to represent how a subclock can be defined by selecting
instants amongst the ones of an underlying (master) clock. They may
be seen as textual versions of chronograms. The corresponding type is
described in the relevant section on <A HREF="#datatype"><FONT COLOR="#000080">Data
types</FONT></A>.</P>
<P>The language also supports Clock declarations and Clock
expressions.</P>
<P STYLE="page-break-before: always">&nbsp;</P>
<H1><A NAME="_Toc178562914"></A>2.Syntax</H1>
<H2><A NAME="_Toc178562915"></A>2.1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Clock / Instant definitions</H2>
<H3>2.1.1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Constraints rules</H3>
<P>The main axiom of the grammar defines constraint rules, their
bodies and clock statements.</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">ConstraintRule::=</SPAN></I></P>
<P STYLE="margin-bottom: 0.42cm"><!--[if gte vml 1]><v:shapetype id="_x0000_t75"
 coordsize="21600,21600" o:spt="75" o:preferrelative="t" path="m@4@5l@4@11@9@11@9@5xe"
 filled="f" stroked="f">
 <v:stroke joinstyle="miter"/>
 <v:formulas>
  <v:f eqn="if lineDrawn pixelLineWidth 0"/>
  <v:f eqn="sum @0 1 0"/>
  <v:f eqn="sum 0 0 @1"/>
  <v:f eqn="prod @2 1 2"/>
  <v:f eqn="prod @3 21600 pixelWidth"/>
  <v:f eqn="prod @3 21600 pixelHeight"/>
  <v:f eqn="sum @0 0 1"/>
  <v:f eqn="prod @6 1 2"/>
  <v:f eqn="prod @7 21600 pixelWidth"/>
  <v:f eqn="sum @8 21600 0"/>
  <v:f eqn="prod @7 21600 pixelHeight"/>
  <v:f eqn="sum @10 21600 0"/>
 </v:formulas>
 <v:path o:extrusionok="f" gradientshapeok="t" o:connecttype="rect"/>
 <o:lock v:ext="edit" aspectratio="t"/>
</v:shapetype><v:shape id="_x0000_i1025" type="#_x0000_t75" alt="" style='width:214.5pt;
 height:37.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image001.jpg"
  o:href="../gammarhtml/martegrammar1_html_390eb53f.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image001.jpg" NAME="Image1" ALIGN=BOTTOM WIDTH=286 HEIGHT=50 BORDER=0><SPAN STYLE="background: #ffffff"><BR></SPAN><I><SPAN STYLE="background: #ffffff">body::=</SPAN></I><SPAN STYLE="background: #ffffff">
</SPAN>
</P>
<P STYLE="margin-top: 0.21cm; background: #ffffff"><!--[if gte vml 1]><v:shape id="_x0000_i1026"
 type="#_x0000_t75" alt="" style='width:180.75pt;height:56.25pt' filled="t"
 fillcolor="black">
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image002.jpg"
  o:href="../gammarhtml/martegrammar1_html_m6996758c.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image085.jpg" NAME="Image2" ALIGN=BOTTOM WIDTH=241 HEIGHT=75 BORDER=0></P>
<P STYLE="margin-top: 0.21cm; background: #ffffff"><I><SPAN STYLE="background: #ffffff">cStatement::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm"><!--[if gte vml 1]><v:shape id="_x0000_i1027" type="#_x0000_t75" alt=""
 style='width:259.5pt;height:47.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image004.jpg"
  o:href="../gammarhtml/martegrammar1_html_m4f29dbf7.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image004.jpg" NAME="Image3" ALIGN=BOTTOM WIDTH=346 HEIGHT=63 BORDER=0><SPAN STYLE="background: #ffffff"><BR></SPAN>A
Constraint consists of a sequence of statements with an optional
guard. A guard specifies when the statement is applied. A guard uses
Boolean expression defined in <A HREF="#Boolean_[boolexpr1]:"><FONT COLOR="#000080">boolExpr</FONT></A>
. 
</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">guard::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1028" type="#_x0000_t75" alt="" style='width:185.25pt;height:37.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image005.jpg"
  o:href="../gammarhtml/martegrammar1_html_2d9d91c5.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image005.jpg" NAME="Image4" ALIGN=BOTTOM WIDTH=247 HEIGHT=50 BORDER=0></SPAN></P>
<H3 STYLE="page-break-before: always"><A NAME="_Toc178562916"></A>2.1.2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Statements</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">statement::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1029" type="#_x0000_t75" alt="" style='width:286.5pt;height:157.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image006.png"
  o:href="../gammarhtml/martegrammar1_html_5f51b35.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image086.jpg" NAME="Image5" ALIGN=BOTTOM WIDTH=382 HEIGHT=210 BORDER=0></SPAN></P>
<P><BR><BR>
</P>
<P><FONT SIZE=4>A statement is one of:</FONT></P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="#ClockDefinition"><FONT COLOR="#000080">ClockDefinition</FONT></A></P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Clock (Clock identifier ) defined by a <A HREF="#0.1.4.ClockExpression_[clockExpr]|outli"><FONT COLOR="#000080">ClockExpression
</FONT></A>
</P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="#0.1.2.InstantDefinition_[instantdef]|ou"><FONT COLOR="#000080">InstantDefinition</FONT></A></P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
An <A HREF="#0.1.5.InstantRelation_[instantRela]:|ou"><FONT COLOR="#000080">InstantRelation</FONT></A>
imposes an ordering or a coincidence between two instants of
different clocks.</P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
A <A HREF="#0.1.6.ClockRelation_[clockRel]:|outline"><FONT COLOR="#000080">ClockRelation</FONT></A>
is more general and imposes constraints on set of instants of
different clocks.</P>
<P STYLE="margin-left: 2.54cm; text-indent: -0.64cm"><FONT FACE="Courier New"><FONT SIZE=2>o</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="#0.1.3.ChronoNFP_[chronoNFP]|outline"><FONT COLOR="#000080">ChronoNFP
</FONT></A>is a constraint that applies to chronometric clocks only,
and specifies time related non functional properties for a
chronometric clock or a group of chronometric clocks. 
</P>
<H3><A NAME="_Toc178562917"></A><A NAME="ClockDefinition"></A>2.1.3.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
ClockDefinition [clockDef]</H3>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">clockDef::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1030" type="#_x0000_t75" alt="" style='width:348.75pt;height:24.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image008.png"
  o:href="../gammarhtml/martegrammar1_html_m180169c8.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image087.jpg" NAME="Image6" ALIGN=BOTTOM WIDTH=465 HEIGHT=33 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm">This rule defines a local Clock ( the
Clock identifier is marked by the <I>local</I> flag ) . This clock
can be defined by a <A HREF="#0.1.4.ClockExpression_[clockExpr]|outli"><FONT COLOR="#000080">ClockExpression
</FONT></A>
</P>
<P STYLE="margin-bottom: 0cm; page-break-before: always">&nbsp;</P>
<H3><A NAME="_Toc178562918"></A><A NAME="0.1.2.InstantDefinition_[instantdef]|out"></A>
2.1.4.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; InstantDefinition [instantDef]</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">instantDef::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1031" type="#_x0000_t75" alt="" style='width:406.5pt;height:47.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image010.png"
  o:href="../gammarhtml/martegrammar1_html_7e8e4a66.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image088.jpg" NAME="Image7" ALIGN=BOTTOM WIDTH=542 HEIGHT=63 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm">This rule defines a local instant &nbsp;(the
instant identifier is marked by the <I>local</I> flag ) . This
instant can be defined by a <A HREF="#InstantRef"><FONT COLOR="#000080">InstantRef</FONT></A>
.</P>
<H2><A NAME="_Toc178562919"></A>2.2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Clock Expression and Clock / Instant relations</H2>
<H3><A NAME="_Toc178562922"></A>2.2.1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
ClockExpression [clockExpr]</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">clockExpr::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape id="_x0000_i1032" type="#_x0000_t75"
 alt="" style='width:355.5pt;height:216.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image012.png"
  o:href="../gammarhtml/martegrammar1_html_61a7273c.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image089.png" NAME="Image8" ALIGN=BOTTOM WIDTH=1108 HEIGHT=459 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm"><BR>
</P>
<P STYLE="margin-bottom: 0cm">A <I>ClockExpression</I> is a
function-like clock relation which returns a <I>Clock</I> derived
from other clocks.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockDiscretization</I>, (<FONT COLOR="#0000ff">keyword :
</FONT><FONT COLOR="#0000ff"><I>discretizedBy</I></FONT><FONT COLOR="#0000ff">
</FONT>) takes a dense <I>ChronometricClock</I>, and returns a
discrete Clock. Parameters: a discretization Step, and an optional
discretization interval.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockFiltering</I>, (<FONT COLOR="#0000ff">keyword : </FONT><FONT COLOR="#0000ff"><I>filteredBy</I></FONT><FONT COLOR="#0000ff">
</FONT>) derives a discrete clock from another discrete clock. Each
instant of the returned clock is coincident with an instant of the
filtered clock. Parameter: a BinaryWord which specifies the filter:
the k<SUP><FONT SIZE=2 STYLE="font-size: 9pt">th</FONT></SUP> instant
of the filtered clock is coincident with an instant of the returned
clock if and only if the k<SUP><FONT SIZE=2 STYLE="font-size: 9pt">th</FONT></SUP>
bit of the BinaryWord is set to 1.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockChaining</I>, (<FONT COLOR="#0000ff">keyword : </FONT><FONT COLOR="#0000ff"><I>followedBy</I></FONT><FONT COLOR="#0000ff">
</FONT>) takes two clocks and returns a new one. The first argument
clock must be finite. The first instants of the returned clock are
coincident with the instants of the first clock. The following
instants are coincident with the instants of the second clock.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockInter</I>, (<FONT COLOR="#0000ff">keyword : </FONT><FONT COLOR="#0000ff"><I>inter</I></FONT><FONT COLOR="#0000ff">
</FONT>) takes 2 clocks and returns a new one which is an
intersection of 2 clocks.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockMinus</I>, (<FONT COLOR="#0000ff">keyword : </FONT><FONT COLOR="#0000ff"><I>minus</I></FONT><FONT COLOR="#0000ff">
</FONT>) takes 2 clocks and returns a new one which is a difference
of 2 clocks.</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockSampling</I>, (<FONT COLOR="#0000ff">keyword :</FONT><FONT COLOR="#ff0000">
</FONT><FONT COLOR="#ff0000"><B>[ modified ]</B></FONT><FONT COLOR="#0000ff">
s</FONT><FONT COLOR="#0000ff"><I>ampledTo</I></FONT><FONT COLOR="#0000ff">
</FONT>) takes 2 clocks and returns a new one. The new clock ticks
when the trigger clock ( 2<SUP>nd</SUP> ClockRef ) has ticked since
the last tick of <SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">(super,
1</SPAN></SPAN><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">st</SPAN></SPAN></SUP>
<SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">ClockRef
)</SPAN></SPAN>. The <I><B>strictly</B></I> <SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">keyword
specifies that the intervals of the sampling clock (super, 1</SPAN></SPAN><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">st</SPAN></SPAN></SUP>
<SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">ClockRef
) are left-closed . By default, they are right-closed .</SPAN></SPAN></P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockRestriction : </I><SPAN STYLE="font-style: normal">takes a
clock and returns a new one</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2><SPAN STYLE="font-style: normal">&middot;</SPAN></FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockRestrtict</I><SPAN STYLE="font-style: normal">, (</SPAN><FONT COLOR="#0000ff"><SPAN STYLE="font-style: normal">keyword
: </SPAN></FONT><FONT COLOR="#0000ff"><I>restrictedTo</I></FONT><FONT COLOR="#0000ff">
</FONT><SPAN STYLE="font-style: normal">) . This new clock ticks
whenever the boolean expression is true.</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockDelay</I>, (<FONT COLOR="#0000ff">keyword :</FONT><FONT COLOR="#ff0000">
</FONT><FONT COLOR="#ff0000"><B>[ modified ]</B></FONT><FONT COLOR="#0000ff">
</FONT><FONT COLOR="#0000ff"><I>restrictedToTrailing</I></FONT><FONT COLOR="#0000ff">
</FONT>). <SPAN STYLE="font-style: normal">The instants of the new
clock are concident with the last instants of the super clock .</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockTruncation</I>, (<FONT COLOR="#0000ff">keyword :</FONT><FONT COLOR="#ff0000">
</FONT><FONT COLOR="#ff0000"><B>[ new ]</B></FONT><FONT COLOR="#0000ff">
</FONT><FONT COLOR="#0000ff"><I>restrictedToLeading</I></FONT>) . <SPAN STYLE="font-style: normal">The
instants of the new clock are concident with the first </SPAN><I><B>n</B></I>
<SPAN STYLE="font-style: normal">instants of the super clock .</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2><SPAN STYLE="font-style: normal">&middot;</SPAN></FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>ClockSlicing </I><SPAN STYLE="font-style: normal">, (</SPAN><FONT COLOR="#0000ff"><SPAN STYLE="font-style: normal">keyword
:</SPAN></FONT><FONT COLOR="#ff0000"> </FONT><FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[
new ]</B></SPAN></FONT><FONT COLOR="#0000ff"> </FONT><FONT COLOR="#0000ff"><I>restrictedToInterval
)</I></FONT> <SPAN STYLE="font-style: normal">. The instants of the
new clock are concident with the instants of interval of the super
clock,</SPAN></P>
<P STYLE="text-indent: -0.64cm"><BR><BR>
</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2><SPAN STYLE="font-style: normal">&middot;</SPAN></FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>TimerConstraint : </I><SPAN STYLE="font-style: normal">special
kinds of clocks . Not to be used as Standard ones .</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2><SPAN STYLE="font-style: normal">&middot;</SPAN></FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<I>timerConstraint , </I><SPAN STYLE="font-style: normal">(</SPAN><FONT COLOR="#0000ff"><SPAN STYLE="font-style: normal">keyword
:</SPAN></FONT><FONT COLOR="#ff0000"> </FONT><FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[
new ]</B></SPAN></FONT><FONT COLOR="#0000ff"> </FONT><FONT COLOR="#0000ff"><I>timerConstraint
)</I></FONT> <SPAN STYLE="font-style: normal">.</SPAN> T<SPAN STYLE="font-style: normal">he
timer counts</SPAN> <I><B>n</B></I> <SPAN STYLE="font-style: normal">(duration
) ticks of super clock (1</SPAN><SUP><SPAN STYLE="font-style: normal">st</SPAN></SUP>
<SPAN STYLE="font-style: normal">ClockRef). The timer is launched by
a clock ( Start , 2</SPAN><SUP><SPAN STYLE="font-style: normal">nd</SPAN></SUP>
<SPAN STYLE="font-style: normal">ClockRef ). The count is aborted by
a tick of a clock ( Stop , 3</SPAN><SUP><SPAN STYLE="font-style: normal">rd</SPAN></SUP>
<SPAN STYLE="font-style: normal">ClockRef ). When the timer elapses ,
the timeout clock ( 4</SPAN><SUP><SPAN STYLE="font-style: normal">th</SPAN></SUP>
<SPAN STYLE="font-style: normal">ClockRef ) ticks .</SPAN></P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><FONT FACE="Symbol"><FONT SIZE=2><SPAN STYLE="font-style: normal">&middot;</SPAN></FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<SPAN STYLE="font-style: normal">o</SPAN><I>neShotConstraint
,</I><SPAN STYLE="font-style: normal">(</SPAN><FONT COLOR="#0000ff"><SPAN STYLE="font-style: normal">keyword
:</SPAN></FONT><FONT COLOR="#ff0000"> </FONT><FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[
new ]</B></SPAN></FONT><FONT COLOR="#0000ff"> </FONT><FONT COLOR="#0000ff"><SPAN STYLE="font-style: normal">o</SPAN></FONT><FONT COLOR="#0000ff"><I>neShotConstraint
)</I></FONT> <SPAN STYLE="font-style: normal">.</SPAN> Same behavior
as the previous one , without Stop Clock .</P>
<P STYLE="margin-left: 1.27cm; text-indent: -0.64cm"><BR><BR>
</P>
<P STYLE="text-indent: -0.64cm"><BR><BR>
</P>
<P STYLE="margin-left: 2cm; text-indent: -0.64cm"><BR><BR>
</P>
<P STYLE="margin-left: 0.64cm">&nbsp;</P>
<P STYLE="margin-left: 0.64cm"><BR><BR>
</P>
<P><A NAME="0.1.5.InstantRelation_[instantRela]:|out"></A><IMG SRC="martegrammar1_html_m27037acd.png" NAME="Image9" ALIGN=LEFT WIDTH=476 HEIGHT=424 BORDER=0><BR CLEAR=LEFT><!--[if gte vml 1]><v:shape
 id="_x0000_s1040" type="#_x0000_t75" alt="" style='position:absolute;
 margin-left:0;margin-top:0;width:357pt;height:318pt;z-index:3;
 mso-wrap-distance-left:0;mso-wrap-distance-right:0;mso-position-horizontal:left;
 mso-position-vertical-relative:line' o:allowoverlap="f">
 <v:imagedata src="martegrammar1_html_m27037acd.png"/>
 <w:wrap type="square"/>
</v:shape><![endif]-->&nbsp;</P>
<P>&nbsp;</P>
<H3>2.2.2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ChronoNFP [chronoNFP]</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">chronoNFP::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1033" type="#_x0000_t75" alt="" style='width:453pt;height:71.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image014.png"
  o:href="../gammarhtml/martegrammar1_html_m73a334e5.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image090.jpg" NAME="Image10" ALIGN=BOTTOM WIDTH=604 HEIGHT=95 BORDER=0></SPAN></P>
<P>A ChronoNFP is a constraint that applies to chronometric clocks
only, and specifies time related non functional properties for a
chronometric clock or a group of chronometric clocks.</P>
<P>The ChronometricClocks package introduces the main concepts
related to clocks bound to physical time . A chronometric clock
provides quantitative information about time. Numerous non functional
time-related properties can be defined for chronometric clocks. Only
a few are presented below.</P>
<P STYLE="margin-bottom: 0cm">The next figure represents, in an
informal way, the dependency of chronometric clocks on physical time.
Physical time is modeled as a dense time base (the Real line). The
instants of the discrete time base associated with a chronometric
clock are coincident with physical instants regularly interspaced on
the real line. In a chronometric clock, the resolution property is
the duration value of physical time elapsed between two consecutive
instants of this clock. Real chronometric clocks do not perfectly
reflect evolution of physical time. Possible defects are
characterized by non functional properties. For instance, stability
is the ability for a clock to report consistent intervals of time.
Stability is measured by derivatives of the clock rate, derivation
against time or against environmental factors.</P>
<P STYLE="margin-bottom: 0cm">When many clocks are present in a
system, other non functional time properties are considered. They are
time-dependent pair-wise characteristics. Usually, one clock is taken
as a reference clock against which the other clock is matched. When
omitted, the reference clock is supposed to be an &ldquo;almost
perfect clock&rdquo;. Two clocks with the same rate may present an
offset. This duration value may vary along time. The rate of change
of the offset (i.e., its first derivative against time) between two
clocks is called the skew. This skew itself may change over time. The
derivative of the skew is called the drift.</P>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0.42cm; page-break-after: avoid">
<!--[if gte vml 1]><v:shape id="_x0000_i1034" type="#_x0000_t75" alt=""
 style='width:300pt;height:308.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image016.png"
  o:href="../gammarhtml/martegrammar1_html_m464e7165.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image091.jpg" NAME="Image11" ALIGN=BOTTOM WIDTH=400 HEIGHT=411 BORDER=0></P>
<P LANG="en-GB" ALIGN=CENTER>Figure<!--[if supportFields]><span
style='mso-element:field-begin'></span><span lang=EN-GB style='mso-ansi-language:
EN-GB'><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC </span><span
style='mso-element:field-separator'></span><![endif]-->
1<!--[if supportFields]><span
style='mso-element:field-end'></span><![endif]--></P>
<P STYLE="margin-bottom: 0.42cm"><BR><BR>
</P>
<H4><A NAME="_Toc178562920"></A>Wrt optional Statement:</H4>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">wrtClock::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape id="_x0000_i1035" type="#_x0000_t75"
 alt="" style='width:151.5pt;height:15pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image018.png"
  o:href="../gammarhtml/martegrammar1_html_37056683.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image092.jpg" NAME="Image12" ALIGN=BOTTOM WIDTH=202 HEIGHT=20 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm">This rule
signifies &laquo;&nbsp;with respect to Clock&nbsp;&raquo;</P>
<H4><A NAME="_Toc178562921"></A>AtExpr optional Statement</H4>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">atInstant::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm; background: #ffffff"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1036" type="#_x0000_t75" alt="" style='width:177.75pt;height:15pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image020.png"
  o:href="../gammarhtml/martegrammar1_html_mea1c64b.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image093.jpg" NAME="Image13" ALIGN=BOTTOM WIDTH=237 HEIGHT=20 BORDER=0></SPAN></P>
<P>This rule specifies the instant(s) at which a property is valid.
If no instant expression is specified, the property is valid at all
instants,</P>
<H3 STYLE="page-break-before: always"><A NAME="_Toc178562923"></A><A NAME="0.1.4.ClockExpression_[clockExpr]|outlin"></A>
2.2.3.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; InstantRelation [instantRel]:</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">InstantRelation::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1037" type="#_x0000_t75" alt="" style='width:453pt;height:69.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image022.jpg"
  o:href="../gammarhtml/martegrammar1_html_234f52b3.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image022.jpg" NAME="Image14" ALIGN=BOTTOM WIDTH=604 HEIGHT=93 BORDER=0></SPAN></P>
<P><BR>An <I>InstantRelation</I> asserts a precedence or a
coincidence constraint between two instants of two different clocks.</P>
<H3><A NAME="_Toc178562924"></A>2.2.4.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
ClockRelation [clockRel]:</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">clockRelation::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><IMG SRC="marteTimeModelDeliverableImage_fichiers/image023.png" NAME="Image15" ALIGN=BOTTOM WIDTH=935 HEIGHT=434 BORDER=0></SPAN></P>
<P><BR><BR>
</P>
<P>Periodicity and sporadicity are respectively denoted by
isPeriodicOn and isSporadicOn. The optional real expression allows
the user to specify the period or the minimal gap between successive
instants of the first clock with respect to the second.</P>
<P>Subclocking is denoted by <FONT COLOR="#0000ff"><I><B>isCoarserThan</B></I></FONT>.
The converse is also offered if b <FONT COLOR="#0000ff"><I><B>isCoarserThan</B></I></FONT>
a, then a <FONT COLOR="#0000ff"><I><B>isFinerThan</B></I></FONT> b. b
is a subclock of a, and a is a superclock of b. 
</P>
<P>RelativeSpeed is expressed by <FONT COLOR="#0000ff"><I><B>isFasterThan</B></I></FONT>,
with the converse relation <FONT COLOR="#0000ff"><I><B>isSlowerThan</B></I></FONT>.
The optional argument <FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[
new ]</B></SPAN></FONT>, after the keyword <FONT COLOR="#0000ff"><I><B>within</B></I></FONT>
<SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">gives
the mininal and the maximal difference between the instant indexes of
the 2 clocks.</SPAN></SPAN></P>
<P><FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[ new ]</B></SPAN></FONT><FONT COLOR="#0000ff">
</FONT><FONT COLOR="#000000">The </FONT><FONT COLOR="#0000ff"><I><B>sync</B></I></FONT><FONT COLOR="#000000">
constraint ( short for synchronized) is a symmetrical relationship :
&laquo;&nbsp; clk1 sync ( a, b ) clk2 ;&nbsp;&raquo; means that : 
<IMG SRC="marteTimeModelDeliverableImage_htm_m61c462f1.gif" NAME="Objet1" ALIGN=ABSMIDDLE HSPACE=8 WIDTH=585 HEIGHT=18 BORDER=0></FONT></P>
<P><FONT COLOR="#0000ff"><I><B>AlternatesWith </B></I><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">is
an asymmetrical relationship between 2 clocks such that the ticks of
the 2</SPAN></SPAN></FONT><FONT COLOR="#000000"><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">nd</SPAN></SPAN></SUP></FONT><FONT COLOR="#000000">
</FONT><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">clock
alternate with the tichs of the 1</SPAN></SPAN></FONT><FONT COLOR="#000000"><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">st</SPAN></SPAN></SUP></FONT><FONT COLOR="#000000">
</FONT><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">clock.
</SPAN></SPAN></FONT><FONT COLOR="#ff0000"><SPAN STYLE="font-style: normal"><B>[
new ]</B></SPAN></FONT> <FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">the
optional argument </SPAN></SPAN></FONT><I><B>strictly</B></I><FONT COLOR="#000000">
</FONT><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">specifies
that an instant of 2</SPAN></SPAN></FONT><FONT COLOR="#000000"><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">nd</SPAN></SPAN></SUP></FONT><FONT COLOR="#000000">
</FONT><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">clock
may possibly coincide with the instant of 1</SPAN></SPAN></FONT><FONT COLOR="#000000"><SUP><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">st</SPAN></SPAN></SUP></FONT><FONT COLOR="#000000">
</FONT><FONT COLOR="#000000"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: medium">clock
with the same index.</SPAN></SPAN></FONT></FONT></P>
<P>Equality is simply denoted by the equality symbol.</P>
<P>The maximalDrift relation being symmetric, the adopted syntax is a
pair of clock references followed by <FONT COLOR="#0000ff"><I><B>haveMaxDrift</B></I></FONT>.
This yields an <B>integer</B> value which is constrained.</P>
<P>A ClockRelation is a relational dependency between instants of
clocks. This is a more general concept than ClockExpression which is
a functional dependency. A ClockRelation imposes a partial ordering
between the instants of the clocks. In what follows, ClockReference
denotes either a Clock or a ClockExpression.</P>
<P>The following clock relations constrain a pair of
ClockReferences.&nbsp;</P>
<P><I>Periodicity</I> imposes that there exists an integer p such
that between each pair of successive instants of a ClockReference,
there exist p instants of the other ClockReference.</P>
<P><I>Sporadicity</I> imposes that there exists an integer g such
that between each pair of successive instants of a ClockReference,
there exist at least g instants of the other ClockReference.</P>
<P><I>Subclocking </I>imposes that there exists an injective mapping
from the instants of one ClockReference onto the instants of the
other ClockReference, such that this mapping preserves the instant
ordering. This relation is a weak form of the <I>ClockFiltering</I>
without an imposed filter.</P>
<P><I>Equality </I>is a strong relation: there exists a one-to-one
mapping between instants of the two ClockReferences, and this mapping
is order preserving.</P>
<P>Some clock relations require a third ClockReference. Each
constrained ClockReference must be subclock of this third
ClockReference.&nbsp;</P>
<P><I>RelativeSpeed</I> imposes that for any integer k, the k<SUP><FONT SIZE=2 STYLE="font-size: 9pt">th</FONT></SUP>
instant of the faster ClockReference precedes the k<SUP><FONT SIZE=2 STYLE="font-size: 9pt">th</FONT></SUP>
instant of the slower ClockReference.</P>
<P><I>MaximalDrift </I>imposes that there exists an integer m such
that for each instant k of the third ClockReference, the absolute
difference between the numbers of instants preceding instant k in the
two ClockReferences is less than or equal to m.</P>
<P><!--[if gte vml 1]><v:shape id="_x0000_i1039"
 type="#_x0000_t75" alt="" style='width:453.75pt;height:363pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image025.png"
  o:href="../gammarhtml/martegrammar1_html_7425f348.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image095.jpg" NAME="Image16" ALIGN=BOTTOM WIDTH=605 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0cm"><!--[if gte vml 1]><v:shape id="_x0000_i1040"
 type="#_x0000_t75" alt="" style='width:453.75pt;height:363pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image027.png"
  o:href="../gammarhtml/martegrammar1_html_m665003e2.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image096.jpg" NAME="Image17" ALIGN=BOTTOM WIDTH=605 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0.42cm"><BR><BR>
</P>
<H2><A NAME="_Toc178562925"></A>2.3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Clock / Instant References</H2>
<H3><A NAME="_Toc178562926"></A><A NAME="InstantRef"></A>2.3.1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Instant [instantRef]:</H3>
<P STYLE="margin-bottom: 0cm">&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">instantRef::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1041" type="#_x0000_t75" alt="" style='width:408.75pt;height:87pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image029.png"
  o:href="../gammarhtml/martegrammar1_html_4a77877c.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image097.jpg" NAME="Image18" ALIGN=BOTTOM WIDTH=545 HEIGHT=116 BORDER=0></SPAN></P>
<P><BR>This rule defines an instant :</P>
<P STYLE="margin-bottom: 0cm">a Instant is</P>
<P STYLE="margin-left: 1.27cm; margin-top: 0.18cm; margin-bottom: 0cm">
<FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
an n<SUP>th </SUP>occurrence of clock tick</P>
<P STYLE="margin-left: 1.27cm; margin-top: 0.18cm; margin-bottom: 0cm">
<FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
an instant identifier 
</P>
<P STYLE="margin-left: 1.27cm; margin-top: 0.18cm; margin-bottom: 0cm">
<FONT FACE="Symbol"><FONT SIZE=2>&middot;</FONT></FONT>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
an occurrence of clock when a Boolean expression is true.</P>
<H3><A NAME="_Toc178562927"></A>2.3.2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Clock [clockRef]</H3>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">clockRef::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1042" type="#_x0000_t75" alt="" style='width:247.5pt;height:39pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image031.png"
  o:href="../gammarhtml/martegrammar1_html_m4cf1f0f2.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image098.jpg" NAME="Image19" ALIGN=BOTTOM WIDTH=330 HEIGHT=52 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm">A clockRef is Either an Identifier or a
bracketed clock expression.</P>
<H2><A NAME="_Toc178562928"></A><A NAME="datatype"></A>2.4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Data Types</H2>
<H3><A NAME="_Toc178562929"></A>2.4.1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Identifier</H3>
<P>&nbsp;</P>
<P>A Identifier is a Simple Identifier or a Path</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">Ident::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1043" type="#_x0000_t75" alt="" style='width:453.75pt;height:45.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image033.jpg"
  o:href="../gammarhtml/martegrammar1_html_179375d7.jpg"/>
 <o:lock v:ext="edit" aspectratio="f"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image099.jpg" NAME="Image20" ALIGN=BOTTOM WIDTH=605 HEIGHT=61 BORDER=0></SPAN></P>
<P><BR>In order to make the syntax cleaner, various kinds of
identifier are distinguished (e.g clockId , instantId , .. ). All are
Idenfiers .</P>
<P>&nbsp;</P>
<P>A Path is a Qualified name of a UML element .</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">Path::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1044" type="#_x0000_t75" alt="" style='width:267pt;height:80.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image035.jpg"
  o:href="../gammarhtml/martegrammar1_html_m37bde9eb.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image035.jpg" NAME="Image21" ALIGN=BOTTOM WIDTH=356 HEIGHT=107 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm; page-break-before: always">
<SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<H3>2.4.2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Real , Integer&nbsp; Values</H3>
<P>&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">numberExpr::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1045" type="#_x0000_t75" alt="" style='width:305.25pt;height:152.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image036.jpg"
  o:href="../gammarhtml/martegrammar1_html_m449e2761.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image036.jpg" NAME="Image22" ALIGN=BOTTOM WIDTH=407 HEIGHT=203 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm">This rule defines a mathematical
expression with classical arithmetic priority for operator. The
sub-rule number is defined by :</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">number::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1046" type="#_x0000_t75" alt="" style='width:276.75pt;height:119.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image037.png"
  o:href="../gammarhtml/martegrammar1_html_30047852.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image100.jpg" NAME="Image23" ALIGN=BOTTOM WIDTH=369 HEIGHT=159 BORDER=0></SPAN></P>
<P>&nbsp;</P>
<P STYLE="margin-top: 0.21cm">Integer and Real constant are defined
as:</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">Int
::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape id="_x0000_i1047" type="#_x0000_t75"
 alt="" style='width:307.5pt;height:80.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image039.png"
  o:href="../gammarhtml/martegrammar1_html_m3e7c7356.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image101.jpg" NAME="Image24" ALIGN=BOTTOM WIDTH=410 HEIGHT=107 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">Real
::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1048" type="#_x0000_t75" alt="" style='width:394.5pt;height:80.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image041.png"
  o:href="../gammarhtml/martegrammar1_html_m49362fe3.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image102.jpg" NAME="Image25" ALIGN=BOTTOM WIDTH=526 HEIGHT=107 BORDER=0></SPAN></P>
<P><BR><BR>
</P>
<P>The Real numbers &nbsp;can have an Exponent which defined as :</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">EXPONENT::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1049" type="#_x0000_t75" alt="" style='width:329.25pt;height:33.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image043.png"
  o:href="../gammarhtml/martegrammar1_html_m4575a84c.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image103.jpg" NAME="Image26" ALIGN=BOTTOM WIDTH=439 HEIGHT=45 BORDER=0></SPAN></P>
<H3><A NAME="_Toc178562932"></A><A NAME="Boolean_[boolexpr1]:"></A>2.4.3.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Boolean [boolexpr]:</H3>
<P>&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">boolexpr::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1050" type="#_x0000_t75" alt="" style='width:312.75pt;height:95.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image045.png"
  o:href="../gammarhtml/martegrammar1_html_m1cc99eb.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image104.jpg" NAME="Image27" ALIGN=BOTTOM WIDTH=417 HEIGHT=127 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm">this rule defines a Boolean expression
with priority for operator ( and , xor , or ) , the sub-rule boolTerm
is define by :</P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P><I><SPAN STYLE="background: #ffffff">boolTerm::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1051" type="#_x0000_t75" alt="" style='width:255pt;height:157.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image047.jpg"
  o:href="../gammarhtml/martegrammar1_html_5a53aed3.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image047.jpg" NAME="Image28" ALIGN=BOTTOM WIDTH=340 HEIGHT=210 BORDER=0></SPAN></P>
<P>&nbsp;</P>
<H4>Comparison operator:</H4>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">comparaison::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1052" type="#_x0000_t75" alt="" style='width:271.5pt;height:181.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image048.jpg"
  o:href="../gammarhtml/martegrammar1_html_170faa5a.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image048.jpg" NAME="Image29" ALIGN=BOTTOM WIDTH=362 HEIGHT=242 BORDER=0></SPAN></P>
<P><A NAME="_Toc178562930"></A>&nbsp;</P>
<H3>2.4.4.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; BinaryWord</H3>
<P>CCSL adds new literals for BitVectors and BinaryWords. A BitVector
is a sequence of bits; a BinaryWord is a pair of BitVectors
consisting of a prefix and a period. Two concrete notations are
provided: a flat notation starting with the `0b&acute; prefix, and
notation with repetition factors starting with the `0B&acute; prefix.</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">binaryWord::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1053" type="#_x0000_t75" alt="" style='width:406.5pt;height:71.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image049.png"
  o:href="../gammarhtml/martegrammar1_html_1450f328.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image105.jpg" NAME="Image30" ALIGN=BOTTOM WIDTH=542 HEIGHT=95 BORDER=0></SPAN></P>
<P><BR>With <I>BITV</I> is a BitVector which defines by</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">Bitv::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1054" type="#_x0000_t75" alt="" style='width:118.5pt;height:71.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image051.png"
  o:href="../gammarhtml/martegrammar1_html_42e61b18.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image106.jpg" NAME="Image31" ALIGN=BOTTOM WIDTH=158 HEIGHT=95 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0cm; page-break-before: always">A Compressed
form use a Compressed BitVector</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">binaryWord::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1055" type="#_x0000_t75" alt="" style='width:384.75pt;height:48.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image053.png"
  o:href="../gammarhtml/martegrammar1_html_m5023c9ae.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image107.jpg" NAME="Image32" ALIGN=BOTTOM WIDTH=513 HEIGHT=65 BORDER=0></SPAN></P>
<P><BR><BR>
</P>
<P STYLE="margin-bottom: 0cm">A generalized BitVector is defined by:<SPAN STYLE="background: #ffffff">
</SPAN>
</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">GBV::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1056" type="#_x0000_t75" alt="" style='width:418.5pt;height:56.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image055.png"
  o:href="../gammarhtml/martegrammar1_html_96e1d80.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image108.jpg" NAME="Image33" ALIGN=BOTTOM WIDTH=558 HEIGHT=75 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">QUANTBIT::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1057" type="#_x0000_t75" alt="" style='width:322.5pt;height:66pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image057.png"
  o:href="../gammarhtml/martegrammar1_html_m226475db.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image109.jpg" NAME="Image34" ALIGN=BOTTOM WIDTH=430 HEIGHT=88 BORDER=0></SPAN></P>
<P><BR><BR>
</P>
<P><FONT SIZE=4><B>Examples of BinaryWords:</B></FONT></P>
<P>0b100(1100)&nbsp; denotes the binary word whose prefix is 100 and
whose period is 1100. In turn, this binary word denotes the infinite
bit vector 100110011001100&hellip;.1100&hellip;</P>
<P>0B1.0^2(1^2.0^2) denotes the same binary word (useful notation
when the exponent is big).</P>
<P>0b(100) denotes the binary word whose prefix is empty and whose
period is 100.</P>
<P>0b110 denotes the binary word whose prefix is 110 and whose period
is empty. Thus, this binary word denotes the finite bit vector: 110.</P>
<P>Note that 0b(0) an infinite sequence of 0, not the empty
BitVector.</P>
<P>The canonic form of BinaryWords is given when 2 BitVectors have a
minimal length.</P>
<P STYLE="margin-bottom: 0cm">BinaryWords 0b100(1100), 0b10(01100110)
and 0b100(11001100) are a same BinaryWords , the canonic form is
0b(1001) ;</P>
<P>&nbsp;</P>
<H3><A NAME="_Toc178562933"></A>2.4.5.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Duration / Instant Expression [durationExpr , instantExpr]</H3>
<P>A Duration or an Instant Expression is a timeValueSpecification
(TVS) . The context defines if it is a duration or Instant term.</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">timeValueSpecification</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1058" type="#_x0000_t75" alt="" style='width:444.75pt;height:61.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image059.png"
  o:href="../gammarhtml/martegrammar1_html_11a24ac4.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image110.jpg" NAME="Image35" ALIGN=BOTTOM WIDTH=593 HEIGHT=82 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0.21cm"><BR>This expression is a time
expression with a optional time unit .</P>
<P STYLE="margin-bottom: 0.21cm">This time unit is references to a
clock. A time expression is a sum (Additive or subtractive ) of
timeTerm .</P>
<P STYLE="margin-bottom: 0.21cm">The first term is a Duration or
Instant term, and the other is only a Duration term.</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">time::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1059" type="#_x0000_t75" alt="" style='width:291pt;height:33.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image061.png"
  o:href="../gammarhtml/martegrammar1_html_m5ff5741c.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image111.jpg" NAME="Image36" ALIGN=BOTTOM WIDTH=388 HEIGHT=45 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0.42cm"><BR>TimeFactor is an elementary term
of TVS expression:</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">timeTerm::=</SPAN></I></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape id="_x0000_i1060" type="#_x0000_t75"
 alt="" style='width:449.25pt;height:39pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image063.png"
  o:href="../gammarhtml/martegrammar1_html_22cd1913.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image112.jpg" NAME="Image37" ALIGN=BOTTOM WIDTH=599 HEIGHT=52 BORDER=0></SPAN></P>
<P><BR>A timeterm is a timefactor can be multiplicated by a
coefficient .</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">timeFactor
::=</SPAN></I><SPAN STYLE="background: #ffffff"> </SPAN>
</P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1061" type="#_x0000_t75" alt="" style='width:365.25pt;height:167.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image065.png"
  o:href="../gammarhtml/martegrammar1_html_44e6ac40.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image113.jpg" NAME="Image38" ALIGN=BOTTOM WIDTH=487 HEIGHT=223 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0.42cm"><BR>the TimeFunc term returns a
minimal (or maximal ) time value .</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">timeFunc::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1062" type="#_x0000_t75" alt="" style='width:432.75pt;height:33.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image067.png"
  o:href="../gammarhtml/martegrammar1_html_m5110261c.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image114.jpg" NAME="Image39" ALIGN=BOTTOM WIDTH=577 HEIGHT=45 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">where
prefixop is : 'min' or 'max'</SPAN></I></P>
<P STYLE="margin-bottom: 0.42cm"><BR><BR>
</P>
<P>The TimeInterval defines a either interval of instant or interval
of duration.</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">timeInterval::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1063" type="#_x0000_t75" alt="" style='width:382.5pt;height:61.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image069.png"
  o:href="../gammarhtml/martegrammar1_html_1cea4e0e.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image115.jpg" NAME="Image40" ALIGN=BOTTOM WIDTH=510 HEIGHT=82 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P>A span returns a Duration Between 2 instant ( 2 time values are
instants ).</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">span::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1064" type="#_x0000_t75" alt="" style='width:449.25pt;height:15pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image071.png"
  o:href="../gammarhtml/martegrammar1_html_m26ec4b1.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image116.jpg" NAME="Image41" ALIGN=BOTTOM WIDTH=599 HEIGHT=20 BORDER=0></SPAN></P>
<P>A tuple is a collection of different data</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">tuple::=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1065" type="#_x0000_t75" alt="" style='width:396.75pt;height:33.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image073.png"
  o:href="../gammarhtml/martegrammar1_html_m1c5d103.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image117.jpg" NAME="Image42" ALIGN=BOTTOM WIDTH=529 HEIGHT=45 BORDER=0></SPAN></P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><I><SPAN STYLE="background: #ffffff">tupleExpr:=</SPAN></I></P>
<P STYLE="margin-bottom: 0cm"><SPAN STYLE="background: #ffffff"><!--[if gte vml 1]><v:shape
 id="_x0000_i1066" type="#_x0000_t75" alt="" style='width:264.75pt;height:61.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image075.png"
  o:href="../gammarhtml/martegrammar1_html_5e01b6cb.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image118.jpg" NAME="Image43" ALIGN=BOTTOM WIDTH=353 HEIGHT=82 BORDER=0></SPAN></P>
<P STYLE="margin-top: 0.21cm; margin-bottom: 0.42cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-bottom: 0.42cm; page-break-before: always">&nbsp;</P>
<H1><A NAME="_Toc178562934"></A>3.Implementation and Usage</H1>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P><A NAME="_Toc178562935"></A>The CCSL language has been implemented
as an Eclipse plug in.</P>
<P>The grammar is written in Java (1.5) and uses the ANTLR syntax
analyzer (version 2.7).</P>
<P>It&rsquo;s therefore compatible with other tool inside the
OpenEmbeDD RNTL platform.</P>
<P>&nbsp;</P>
<P>The CCSL specification can be uploaded into a UML modeler as a
standalone plug in. Nevertheless it&rsquo;s interpretation requires
the aviability of the MARTE profile in the modeler.</P>
<H2>3.1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Plug-in Usage</H2>
<P>You can select a context menu of Uml Constraint for launching a
CCSL parser on this constraint.</P>
<P>Select a sub-menu CT-RTE, next ClockConstraint parser.</P>
<P><IMG SRC="martegrammar2_html_m26a28f52.png" NAME="Image44" ALIGN=LEFT WIDTH=565 HEIGHT=133 BORDER=0><BR CLEAR=LEFT><!--[if gte vml 1]><v:shape id="_x0000_s1033" type="#_x0000_t75" alt=""
 style='position:absolute;margin-left:0;margin-top:0;width:423.75pt;height:99.75pt;
 z-index:1;mso-wrap-distance-left:0;mso-wrap-distance-right:0;
 mso-position-horizontal:left;mso-position-vertical-relative:line'
 o:allowoverlap="f">
 <v:imagedata src="martegrammar2_html_m26a28f52.png"/>
 <w:wrap type="square"/>
</v:shape><![endif]-->&nbsp;</P>
<P>&nbsp;</P>
<P>You can select a context menu of Uml Model for launching a CCSL
parser for all constraint of the model, stereotyped by
&lt;&lt;clockConstaint&gt;&gt;.</P>
<P>Select a sub-menu CT-RTE, next CCSL parser.</P>
<P>&nbsp;</P>
<P><A NAME="_Toc178562936"></A><IMG SRC="martegrammar2_html_m21234e4d.png" NAME="Image45" ALIGN=LEFT WIDTH=533 HEIGHT=158 BORDER=0><BR CLEAR=LEFT><!--[if gte vml 1]><v:shape id="_x0000_s1034" type="#_x0000_t75" alt=""
 style='position:absolute;margin-left:0;margin-top:0;width:399.75pt;height:118.5pt;
 z-index:2;mso-wrap-distance-left:0;mso-wrap-distance-right:0;
 mso-position-horizontal:left;mso-position-vertical-relative:line'
 o:allowoverlap="f">
 <v:imagedata src="martegrammar2_html_m21234e4d.png"/>
 <w:wrap type="square"/>
</v:shape><![endif]-->&nbsp;</P>
<H2>3.2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Error
messages</H2>
<P>&nbsp;</P>
<P>When invoked, the CCSL parser will perform several sanity checks
before the actual parsing. It will report several type of error (and
stop there after).</P>
<P>&nbsp;</P>
<P STYLE="page-break-after: avoid"><!--[if gte vml 1]><v:shape id="_x0000_i1067"
 type="#_x0000_t75" alt="" style='width:453.75pt;height:592.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image077.png"
  o:href="../gammarhtml/martegrammar2_html_m2a4d8486.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image119.jpg" NAME="Image46" ALIGN=BOTTOM WIDTH=605 HEIGHT=790 BORDER=0></P>
<P LANG="en-GB">Figure<!--[if supportFields]><span
style='mso-element:field-begin'></span><span lang=EN-GB style='mso-ansi-language:
EN-GB'><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC </span><span
style='mso-element:field-separator'></span><![endif]-->
2<!--[if supportFields]><span
style='mso-element:field-end'></span><![endif]--></P>
<P>&nbsp;</P>
<P>The figure above describes the various error cases for a
ClockConstaint.</P>
<P ALIGN=CENTER STYLE="margin-top: 0.42cm; margin-bottom: 0.42cm">&nbsp;</P>
<H1><A NAME="_Toc178562937"></A>4.Examples of MARTE models using CCSL
clock constraints</H1>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<H2><A NAME="_Toc178562938"></A>4.1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Chronometric clocks</H2>
<P>The MARTE::TimeLibrary contains the description (<I>IdealClock</I>,
a class stereotyped by <I>ClockType</I>) and an instance (<I>idealClk</I>)
of an &ldquo;ideal&rdquo; clock. Starting with this clock, the user
can define new chronometric clocks, as shown in Figure 3. These
chronometric clocks may present deviations with respect to the ideal
clock.</P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P STYLE="margin-top: 0.21cm; page-break-after: avoid"><!--[if gte vml 1]><v:shape
 id="_x0000_i1068" type="#_x0000_t75" alt="" style='width:421.5pt;height:308.25pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image079.png"
  o:href="../gammarhtml/martegrammar3_html_53dbec35.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image120.jpg" NAME="Image47" ALIGN=BOTTOM WIDTH=562 HEIGHT=411 BORDER=0></P>
<P><SPAN LANG="en-GB">Figure<!--[if supportFields]><span
style='mso-element:field-begin'></span><span lang=EN-GB style='mso-ansi-language:
EN-GB'><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC </span><span
style='mso-element:field-separator'></span><![endif]-->
3<!--[if supportFields]><span
style='mso-element:field-end'></span><![endif]--></SPAN>
<SPAN LANG="en-GB">Example of chronometric clocks</SPAN></P>
<P>&nbsp;</P>
<P>&nbsp;</P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-top: 0.21cm"><SPAN STYLE="background: #ffffff">&nbsp;</SPAN></P>
<P STYLE="margin-bottom: 0.42cm"><BR><BR>
</P>
<P>First, the user specifies a new <I>ClockType</I>: <I>Chronometric</I>,
which is discrete, not logical (i.e., chronometric), and with a read
only attribute (<I>resolution</I>).</P>
<P>Instances of clocks belong to timed domains. In this example only
one time domain is considered, and it owns 3 clocks: <I>idealClk</I>,
which is an instance of <I>IdealClock</I>, <I>cc1</I> and <I>cc2</I>,
which are two instances of <I>Chronometric</I>.</P>
<P><I>cc1</I> and <I>cc2</I> use <I>s</I> (second) as their unit of
time, have a resolution of 0.01 s and adopt the UTC system of time.
The deviations of these clocks with respect to the ideal one are
specified by a clock constraint. Clock constraints are expressed
using a simple declarative language, called CCSL (Clock Constraint
Specification Language), described in Annex C.</P>
<P>The clock constraint in Figure imposes to <I>cc1</I> and <I>cc2</I>
to be almost periodic (stability=10<SUP>-5</SUP>), with a period of
10 ms, and with an offset between the two clocks no greater than 5
ms. Note that the 10 ms period must be consistent with the given
resolution (0.01 s = 10 ms). The first line, in the body of the
constraint, declares a clock <I>c</I>, local to the constraint and
not part of the system. <I>c</I> is defined as an ideal discrete
clock whose resolution is 0.001 s = 1 ms. The other lines are
constraints. Figure 4 represents a time structure that satisfies the
given clock constraint.</P>
<P>&nbsp;</P>
<P STYLE="margin-top: 0.21cm; page-break-after: avoid"><!--[if gte vml 1]><v:shape id="_x0000_i1069"
 type="#_x0000_t75" alt="" style='width:397.5pt;height:102.75pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image081.png"
  o:href="../gammarhtml/martegrammar3_html_39e6eeb3.png"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image121.jpg" NAME="Image48" ALIGN=BOTTOM WIDTH=530 HEIGHT=137 BORDER=0></P>
<P><SPAN LANG="en-GB">Figure<!--[if supportFields]><span
style='mso-element:field-begin'></span><span lang=EN-GB style='mso-ansi-language:
EN-GB'><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC </span><span
style='mso-element:field-separator'></span><![endif]-->
4<!--[if supportFields]><span
style='mso-element:field-end'></span><![endif]--></SPAN>
<SPAN LANG="en-GB">Instants of clocks cc1 and cc2</SPAN></P>
<P STYLE="margin-top: 0.21cm"><BR><BR>
</P>
<P STYLE="margin-bottom: 0.42cm"><BR><BR>
</P>
<H2><A NAME="_Toc178562939"></A>4.2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Logical clocks</H2>
<P>In this simplified example, a processor executes the same code for
several controllers (Figure 5). The processor is a Voltage Scaling
processor: its frequency can be dynamically controlled. For
simplicity, only two frequencies are considered: the frequency in the
full power mode, and the frequency in the low power mode, which is
half the former. The Boolean attribute <I>inLowPower</I> indicates
the running mode of the processor. The control must be applied
periodically (the <I>period</I> attribute of the <I>Controller</I>)
by executing some code (<I>pidCode</I> which is an <I>OpaqueBehavior</I>).
The behavior of the controller is specified by a state machine
(<I>ctrlBeh</I>).</P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P STYLE="margin-top: 0.21cm; page-break-after: avoid"><!--[if gte vml 1]><v:shape
 id="_x0000_i1070" type="#_x0000_t75" alt="" style='width:454.5pt;height:100.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image083.jpg"
  o:href="../gammarhtml/martegrammar3_html_m126127a8.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image083.jpg" NAME="Image49" ALIGN=BOTTOM WIDTH=606 HEIGHT=134 BORDER=0></P>
<P><SPAN LANG="en-GB">Figure<!--[if supportFields]><span
style='mso-element:field-begin'></span><span lang=EN-GB style='mso-ansi-language:
EN-GB'><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC </span><span
style='mso-element:field-separator'></span><![endif]-->
5<!--[if supportFields]><span
style='mso-element:field-end'></span><![endif]--></SPAN>&nbsp;<SPAN LANG="en-GB">:
Example of timed control</SPAN></P>
<P STYLE="margin-top: 0.21cm"><BR><BR>
</P>
<P STYLE="margin-bottom: 0.42cm"><BR><I>pidCode</I> is a behavior
that is executed in a fixed and known number of processor cycles.
This can be modeled with a logical clock. To this end, the class
<I>Processor</I> is stereotyped by <I>ClockType</I>. This mixture of
physical time (period of activation) and logical time (execution
duration expressed in processor cycles) is usual in control
applications.</P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;Figure 6 represents instances
and a clock constraint. The <I>TimedDomain</I> is not explicitly
represented. There are two instances of <I>Controller</I>, with
periods of activation equal to 1 and 2 ms, respectively. Each
execution of <I>pidCode</I> takes 100 cycles of the processor, which
is expressed by a <I>TimedProcessing</I>. The dependency between the
processor cycle duration and the physical time is specified by a
<I>ClockConstraint</I>. The constraint specification indicates that
the local <I>Clock</I> c is a discrete clock with a period of 1 us
(1E-6 s). <I>Clock</I> <I>pr</I> is derived from c.&nbsp; The period
of <I>pr</I> is 20 us when running in the low power mode, and 10 us
in the full power mode. The trigger of the transition labeled &ldquo;after
p&rdquo; in the state machine, implicitly declares a <I>TimeEvent</I>
with <I>isRelative</I> = true and <I>when</I> = p. This <I>TimeEvent</I>
is stereotyped by <I>TimedEvent</I> with <I>on</I> = <I>idealClk</I>.</P>
<P STYLE="margin-top: 0.21cm; page-break-after: avoid"><!--[if gte vml 1]><v:shape
 id="_x0000_i1071" type="#_x0000_t75" alt="" style='width:428.25pt;height:118.5pt'>
 <v:imagedata src="marteTimeModelDeliverableImage_fichiers/image084.jpg"
  o:href="../gammarhtml/martegrammar3_html_m54525fec.jpg"/>
</v:shape><![endif]--><IMG SRC="marteTimeModelDeliverableImage_fichiers/image084.jpg" NAME="Image50" ALIGN=BOTTOM WIDTH=571 HEIGHT=158 BORDER=0></P>
<P>Figure<!--[if supportFields]><span style='mso-element:
field-begin'></span><span style='mso-spacerun:yes'> </span>SEQ Figure \* ARABIC
<span style='mso-element:field-separator'></span><![endif]-->
6<!--[if supportFields]><span style='mso-element:
field-end'></span><![endif]-->
: Clock and TimedProcessing</P>
<P STYLE="margin-top: 0.21cm"><BR><BR>
</P>
<P STYLE="margin-top: 0.21cm"><BR><BR>
</P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
<P STYLE="margin-bottom: 0.42cm">&nbsp;</P>
</BODY>
</HTML>